#include<stdio.h>
#include<stdbool.h>
#include"../src/amgs_c_interface.h"

int main(int argc, char *argv[])
{
  int width,rowsize,nnz;
  int row,i;
  int *crs_index, *crs_column;
  int maxiter;
  double threshold;
  double *crs_val,*B,*X;
  bool flag;
  
  scanf("%d", &width);
  rowsize = width*width;
  
  crs_index = (int *)malloc(sizeof(int)*(rowsize+1));
  crs_column= (int *)malloc(sizeof(int)*5*rowsize);
  crs_val   = (double *)malloc(sizeof(double)*5*rowsize);
  
  crs_index[0]=0;
  
  i=0;
  for(row=0; row < rowsize; row++){
    if(row-width >= 0){
      crs_val[i]= -1.0; crs_column[i++]=row-width;
    }
    if(row % width != 0){
      crs_val[i]= -1.0; crs_column[i++]=row-1;
    }
    crs_val[i]=4.0; crs_column[i++]=row;
    if((row+1)% width != 0){
      crs_val[i]= -1.0; crs_column[i++]=row+1;
    }
    if(row+width < rowsize){
      crs_val[i]= -1.0; crs_column[i++]=row+width;
    }
    crs_index[row+1]=i;
  }
  nnz=i;
  

  B = (double *) malloc(sizeof(double)*rowsize);
  X = (double *) malloc(sizeof(double)*rowsize);

  // right hand side vector is set
  for(row=0;row<rowsize;row++){
    B[row] = 0.0;
    for(i=crs_index[row];i < crs_index[row+1]; i++)
      B[row] += crs_val[i];
  }


  // -------------------------------------------------------
  // *** AMG parameters is set from AMGS_OPTION.dat file ***
  // -------------------------------------------------------
  //amgs_c_parameter_set();
  amgs_c_parameter_option_file();
  amgs_c_option_info(1);


  // ----------------------------------------------------------
  // *** crs problem matrix is stored in amgs libary module ***
  // ----------------------------------------------------------
  amgs_c_store_problem_matrix(crs_index, crs_column, crs_val, rowsize, rowsize*5);


  // ----------------------------------
  // *** terminal condition is set ***
  // ----------------------------------
  maxiter=20;
  threshold=1e-7;
  amgs_c_terminal_val_set(threshold);


  // ----------------------------------
  // *** AMG_solver is called ***
  // ----------------------------------
  flag=false;
  amgs_c_solver(X, B, rowsize, &maxiter, false);

  // -------------------------------------------------------------------
  // *** clear problem matrix and multi-level data in library module ***
  // -------------------------------------------------------------------
  amgs_c_clear_matrices();
  
  return 0;
}
