!C   Copyright (C) 2012 High Performance Computing Laboratory, Kogakuin University.
!C   All rights reserved.
!C
!C   Redistribution and use in source and binary forms, with or without
!C   modification, are permitted provided that the following conditions are met:
!C   1. Redistributions of source code must retain the above copyright
!C      notice, this list of conditions and the following disclaimer.
!C   2. Redistributions in binary form must reproduce the above copyright
!C      notice, this list of conditions and the following disclaimer in the
!C      documentation and/or other materials provided with the distribution.
!C   3. Neither the name of the project nor the names of its contributors
!C      may be used to endorse or promote products derived from this software
!C      without specific prior written permission.
!C
!C   THIS SOFTWARE IS PROVIDED BY HIGH PERFORMANCE COMPUTING LABORATORY IN 
!C   KOGAKUIN UNIVERSITY ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
!C   INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
!C   FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
!C   THE HIGH PERFORMANCE COMPUTING LABORATORY BE LIABLE FOR ANY DIRECT, 
!C   INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
!C   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
!C   LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND 
!C   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
!C   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
!C   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

module amg_parameter
  include 'precision.inc'

  !C gs_kind == 0,1 : symmetric GS, GS.
  integer(kind=kint) :: cycle_kind=0, number_of_vectors = 5, gs_kind=0
  integer(kind=kint) :: iteration_number_up=1, iteration_number_down=1, iteration_number_bottom=30
  integer(kind=kint) :: f_first_iteration_number=0, method=0, MAX_LEVEL_SIZE=20, MIN_NODE_SIZE=100
  real(kind=kreal)   :: theta=0.25, dump_jacobi_weight=0.6666, dump_gauss_seidel_weight=1.0
  real(kind=kreal)   :: theta_reduction_rate=0.8
  character(len=20)  :: solver_string="GMRES", conv_check_str
  character(len=20)  :: AT_string, dummy
  integer(kind=kint) :: AT_interval=100, AT_diff=5, AT_setup=0, AT_init=-1
  !C AT_init shows 
  logical :: conv_check_fl = .false.
  
end module amg_parameter
