!C   Copyright (C) 2012 High Performance Computing Laboratory, Kogakuin University.
!C   All rights reserved.
!C
!C   Redistribution and use in source and binary forms, with or without
!C   modification, are permitted provided that the following conditions are met:
!C   1. Redistributions of source code must retain the above copyright
!C      notice, this list of conditions and the following disclaimer.
!C   2. Redistributions in binary form must reproduce the above copyright
!C      notice, this list of conditions and the following disclaimer in the
!C      documentation and/or other materials provided with the distribution.
!C   3. Neither the name of the project nor the names of its contributors
!C      may be used to endorse or promote products derived from this software
!C      without specific prior written permission.
!C
!C   THIS SOFTWARE IS PROVIDED BY HIGH PERFORMANCE COMPUTING LABORATORY IN 
!C   KOGAKUIN UNIVERSITY ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
!C   INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
!C   FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
!C   THE HIGH PERFORMANCE COMPUTING LABORATORY BE LIABLE FOR ANY DIRECT, 
!C   INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
!C   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
!C   LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND 
!C   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
!C   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
!C   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

MODULE amgs_module
  
  ! data_creation()
  use data_creation_stuben, only: amgs_setup=>setup_phase, &
  &  amgs_clear_matrices=>clear_matrices, amgs_mat_out=> matrix_out

  ! solvers()
  use solver, only: amgs_conv_state=>conv_state

  ! subroutines for terminal conditions
  use terminal_condition, only: amgs_terminal_val_set=>terminal_cond_val_set, &
       & amgs_terminal_vec_set=>terminal_cond_vec_set,                        &
       & amgs_terminal_vec_clear=>terminal_cond_vec_clear

  use problem_matrix, only: amgs_store_problem_matrix=>store_problem_matrix, &
       & amgs_set_null_space_constant=>set_null_space_constant
  

  ! amg_parameter_set  
  use parameter_at, only: amgs_solver=>AMG_solver_include_AT, &
       & amgs_parameter_set=>amg_parameter_set, &
       & amgs_parameter_set_arg=>amg_parameter_set2, &
       & amgs_set_expected_call_times =>set_expected_call_times, &
       & amgs_parameter_option_file=>amg_parameter_option_file, &
       & amgs_option_info=>print_amg_option_range 

  
  
end module amgs_module







