/** @file  gpu_solver.h
    @brief GPUAMGˡ
    @author Kosuke Takahashi
*/

#ifndef __GPU_SOLVER_H
#define __GPU_SOLVER_H


/**
 * ޥåɤγؿMPIΥץֹϿ
 * ѤǥХꤵ
 * @param [in] Level_NUM ޥåɤγؿ
 * @param [in] rank      MPIΥץֹ
 * @return ʤ
 */
extern "C"
void notify_level_(int *Level_NUM);


/**
 * Ѥ륽ФȲ®Ͽ
 * @param [in] select 0:AMG 1:AMG-BiCGSTAB(ߤϥǥХå)
 * @param [in] omega  ®
 * @return ʤ
 */
extern "C"
void parameter_set_on_gpu_(int *select, double *omega, int* iter_down, int* iter_bottom, int* gs_at_lev1);
//void parameter_set_on_gpu_(int *select, double *omega);


/**
 * ƳؤΥåɤ̿ơ֥Ͽ
 * @param [in] Level
 * @param [in] A
 * @param [in] INPORT_COMM_TABLE
 * @param [in] EXPORT_COMM_TABLE
 * @param [in] R&P
 * @param [in] INTER_INPORT_COMM_TABLE
 * @param [in] INTER_EXPORT_COMM_TABLE
 * @return ʤ
 */
extern "C"
void store_mat_on_gpu_(int *Level, 
					  int *N, int *NP, int *NPL, int *NPU, 
					  int *INL, int *INU, 
					  int *IAL, double *AL, 
					  int *IAU, double *AU, 
					  double *D,

					  int *R_N, int *P_N, int *R_NP, int *P_NP, int *R_NPLU, int *P_NPLU, 
					  int *R_IN, int *R_CN, double *R_V,
					  int *P_IN, int *P_CN, double *P_V);


/**
 * «ȽѤͥ٥ȥϿ
 * @param [in] restol  ͥ٥ȥ
 * @param [in] rowsize ͥ٥ȥ륵
 * @return ʤ
 */
extern "C"
void amgs_terminal_vec_set_on_gpu_(double *restol, int *rowsize);


/**
 * «ȽѤͤϿ
 * @param [in] residual 
 * @return ʤ
 */
extern "C"
void amgs_terminal_val_set_on_gpu_(double *residual);


/**
 * Фȿ
 * @param [in,out] x    in:̤ο out:
 * @param [in]     b    ե٥ȥ
 * @param [in,out] iter in:ȿ¿ out:ȿ̿
 * @return ʤ
 */
extern "C"
void solve_on_gpu_(double *x, double *b, int *iter);

/**
 * GPUAMGˡǻѤƲ
 * @return ʤ
 */
extern "C"
void clear_mat_on_gpu_(void);


#endif /* __GPU_SOLVER_H */
