#ifndef __myCUDA_H
#define __myCUDA_H

#include <stdio.h>
//#include <cutil.h>
void CUDA_INIT(int argc, char** argv);
void CUDA_EXIT(int argc, char** argv);
void CUDA_SETUP(int rank);
void CUDA_SYNCHRONIZE(void);
void CUDA_MALLOC(void **devptr, size_t count, char str[]);
void *CUDA_MALLOC_HOST(size_t count, char str[]);
void CUDA_FREE(void *devptr);
void CUDA_FREE_HOST(void *devptr);
void CUDA_MEMSET(void *devptr, int c, size_t count);
void CUDA_COPY(void *dst, const void *src, size_t count);
void CUDA_SEND(void *dst, const void *src, size_t count);
void CUDA_LOAD(void *dst, const void *src, size_t count);
void CUDA_LAST_ERROR_CHECK(void);

void CUDA_RAND(double *a, int n);
void CUDA_ADD(double *a, double *b, double *c, double alpha, int n);
void CUDA_SCALAR_MUL(double a, double *b, double *c, int n);

void CUDA_EXTRACT(double *dst, const double *src, const int *ordering, const int n);
void CUDA_SPRAY(double *dst, const double *src, const int *ordering, const int n);

#endif /* __myCUDA_H */
