#ifndef __MY_SMOOTHER_H
#define __MY_SMOOTHER_H

#include "AMG_define_struct.h"

void CUDA_Jacobi(level_object *lv_obj);
void CUDA_GaussSeidel(level_object *lv_obj);
void CUDA_JCGS(level_object *lv_obj);
void CUDA_IDR_Jacobi(level_object *lv_obj);
void CUDA_CG(level_object *lv_obj);
void CUDA_ResidualError(lu_icrss &da, double *dx, double *db, double *de);
void CUDA_TransitionMatrix(icrss &da, double *db, double *dc);
void CUDA_ReTransitionMatrix(icrss &da, double *db, double *dc);

double CUDA_TwoNormRelativeError(lu_icrss &a, double *dx, double *db);
double CUDA_Dot(double *da, double *db, int np);

bool CUDA_VectorLess(double *dx, double *dy, int n);

bool CUDA_TerminalVal(object *obj);
bool CUDA_TerminalVec(object *obj);

void CUDA_FUNC_0(double *dp, double *dr, double *dv, double beta, double omega, int np);
void CUDA_FUNC_1(double *ds, double *dr, double *dv, double alpha, int np);
void CUDA_FUNC_2(double *dx, double *dpt, double *dst, double alpha, double omega, int np);

void CUDA_MMULT(lu_icrss &da, double *db, double *dc);

#endif /* __MY_SMOOTHER_H */
