#ifndef __MY_SPARSE_MATRIX_H
#define __MY_SPARSE_MATRIX_H

#include <vector>


class crs{
public:
	int n;
	int np;
	int nplu;

	int *dsp;
	int *col;
	double *val;

	crs();
};


class lu_crs{
public:
	int n;
	int np;
	int npl;
	int npu;

	int *inl;
	int *inu;
	int *ial;
	int *iau;

	double *al;
	double *au;
	double *d;

	lu_crs();

	void malloc(int n, int np, int npl, int npu);
	void free(void);
};


class icrs{
public:
	bool original;

	int n;
	int np;
	int nplu;
	int row;

	int *cnt;
	int *col;
	double *val;

	icrs();
	icrs(const icrs& other);
	~icrs();
};
typedef std::vector<icrs> icrss;

class lu_icrs{
public:
	bool original;

	int n;
	int np;
	int nplu;
	int row;

	int *cnt;
	int *col;
	double *val;
	double *d;

	lu_icrs();
	lu_icrs(const lu_icrs& other);
	~lu_icrs();
};
typedef std::vector<lu_icrs> lu_icrss;

#endif /* _MY_SPARSE_MATRIX_H */
