/*
   Copyright (C) 2012 High Performance Computing Laboratory, Kogakuin University.
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:
   1. Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
   2. Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
   3. Neither the name of the project nor the names of its contributors
      may be used to endorse or promote products derived from this software
      without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY HIGH PERFORMANCE COMPUTING LABORATORY IN 
   KOGAKUIN UNIVERSITY ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
   INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
   FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
   THE HIGH PERFORMANCE COMPUTING LABORATORY BE LIABLE FOR ANY DIRECT, 
   INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
   LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND 
   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include "myTime.h"
#include <stdio.h>

/*饿¬˴ؤ*/
#if defined(linux)||defined(__linux)||defined(__linux__)||defined(unix)||defined(__unix)||defined(__unix__)

#include <sys/time.h>

/*
   ؿ̾GetSec
   void
   ֤͡double
   ư֤
*/
double GetSec()
{
    struct timeval tv;
    gettimeofday(&tv, NULL);
    return tv.tv_sec + (double)tv.tv_usec*1e-6;
}

#endif

#if defined(_WIN32)||defined(_WIN64)

#include <time.h>

/*
   ؿ̾GetSec
   void
   ֤͡double
   ư֤
*/
double GetSec()
{
    return (double)clock() / CLOCKS_PER_SEC;
}

#endif

/* 
   ؿ̾: Start
     : *double
   ֤: void
   ư  : ¬򳫻Ϥ
*/
void Start(double *elapsed_time)
{
	*elapsed_time = 0;
	*elapsed_time -= GetSec();
	return;
}

/* 
   ؿ̾: Stop
     : *double
   ֤: void
   ư  : ¬λ 
*/
void Stop(double *elapsed_time)
{
	*elapsed_time += GetSec();
	return;
}

/* 
   ؿ̾: Show
     : double
   ֤: void
   ư  : ¬̤ɽ
*/
void Show(double elapsed_time)
{
	printf("time:%6.4lfsec\n", elapsed_time);
	return;
}

/* 
   ؿ̾: ShowFLOPS
     : double, double
   ֤: void
   ư  : FLOPSɽ
*/
void ShowFLOPS(double elapsed_time, double step)
{
	printf("FLOPS:%6.2lf GFlops\n", step / elapsed_time / (1000.0 * 1000.0 * 1000.0) );
	return;
}

/* 
   ؿ̾: ShowTR
     : double, double
   ֤: void
   ư  : ž®٤ɽ
*/
void ShowTR(double elapsed_time, double byte)
{
	printf("Transfer rate:%6.2lf GByte/sec\n", byte / elapsed_time / (1024.0 * 1024.0 * 1024.0) );
	return;
}

/*ޤǥ¬˴ؤ*/
